<?php if (!defined('PmWiki')) exit();
// See precode/README
if (file_exists("cookbook/precode/precode.php")) {
  $EnablePrecode = 1;
  include_once('cookbook/precode/precode.php');
}

$HTMLHeaderFmt['Geshi'] =  <<<EOF

<style type='text/css'><!--
pre .layer1, pre {
  font-family: monospace;
  /* padding: 0.5em; color: #000000; font-size: small; */
}
pre .layer1 {
  /* padding: 0.5em 0; */
}
--></style>

EOF;

function PreCode2($pagename, $text, $args = '') {

	global $HTMLHeaderFmt, $HTMLFooterFmt, $HTMLStylesFmt;
	$PreCode = _PreCode($pagename, $text, $args);
	extract($PreCode, EXTR_OVERWRITE);

	/////// ADJUST VALUES ///////

	# include geshi ( not working in php-8.1.x yet)
	include_once '../../../pub/lib/geshi/1.0.9.0/geshi.php';

	/////////////////////////////

	$lang = trim($lang);
	if(isset($lang) && ! empty($lang) ) { $language = $lang; }

	if(isset($language)) {

		$text = str_replace(array('<:vspace>', '&lt;', '&gt;', '&amp;'),
				array('', '<', '>', '&'), $text);

		if($language === 'html') { $lang = $language = 'html4strict'; }
		$geshi = new GeSHi($text, $language);
		$geshi->enable_keyword_links(false);
		$geshi->set_header_type(GESHI_HEADER_NONE);
		$geshi->enable_classes();
		$styles = $geshi->get_stylesheet();

		$text = $geshi->parse_code();
		$text = str_replace(array('<br>','<br />'), '', $text);

		$HTMLStylesFmt['GeSHi_'.$language] =  $styles;

	}

	static $highlights = array();
	include('adapter.base.php');

	$_id = " id='$id'"; $_idc = " id='$idc'";
	$_c = isset($args['classreset']) ? $args['classreset'].$args['_c'] : '';
	$_c1 = ' class="'.$args['theme'].$showlines.' hs '.@$args['classreset'].'"';
	$_c2 = ' class="'.$lang.' '.$_c.'"';
	return Keep('<pre'.$_id.$_c1.'><code'.$_idc.$_c2.'>'.$text.'</code></pre>');

}

