<?php if (!defined('PmWiki')) exit();


// LoadHighlightJS();

function LoadHighlightJS($lang='', $theme='') {

/////// ADJUST VALUES ///////

    $HighlightJSPath = '/pub/lib/highlightjs/9.13.1';
    $themes70 =  array( # version 7.0
        'arta', 'ascetic', 'brown_paper', 'dark', 'default', 'far',
        'github', 'googlecode', 'idea', 'ir_black', 'magula', 'monokai',
        'pojoaque', 'rainbow', 'school_book', 'solarized_dark', 'solarized_light',
        'sunburst', 'tomorrow', 'tomorrow-night-blue', 'tomorrow-night-bright',
        'tomorrow-night', 'tomorrow-night-eighties', 'vs', 'xcode', 'zenburn'
    );
    $themes80 =  array( # version 8.0
        'arta', 'atelier-lakeside.light', 'github', 'paraiso.dark', 'tomorrow',
        'ascetic', 'atelier-seaside.dark', 'googlecode', 'paraiso.light', 'tomorrow-night-blue',
        'atelier-dune.dark', 'atelier-seaside.light', 'idea', 'pojoaque', 'tomorrow-night-bright',
        'atelier-dune.light', 'brown_paper', 'ir_black', 'railscasts', 'tomorrow-night',
        'atelier-forest.dark', 'dark', 'magula', 'rainbow', 'tomorrow-night-eighties',
        'atelier-forest.light', 'default', 'mono-blue', 'school_book', 'vs',
        'atelier-heath.dark', 'docco', 'monokai', 'solarized_dark', 'xcode',
        'atelier-heath.light', 'far', 'monokai_sublime', 'solarized_light', 'zenburn',
        'atelier-lakeside.dark', 'foundation', 'obsidian', 'sunburst'
    );
    $themes9131 =  array( # version 9.13.1
        'a11y-dark', 'atelier-lakeside-dark', 'darkula', 'isbl-editor-light', 'rainbow',
        'a11y-light', 'atelier-lakeside-light', 'default', 'kimbie.dark', 'routeros',
        'agate', 'atelier-plateau-dark', 'docco', 'kimbie.light', 'school-book',
        'androidstudio', 'atelier-plateau-light', 'dracula', 'lightfair', 'shades-of-purple',
        'an-old-hope', 'atelier-savanna-dark', 'far', 'magula', 'solarized-dark',
        'arduino-light', 'atelier-savanna-light', 'foundation', 'mono-blue', 'solarized-light',
        'arta', 'atelier-seaside-dark', 'github', 'monokai', 'sunburst',
        'ascetic', 'atelier-seaside-light', 'github-gist', 'monokai-sublime', 'tomorrow',
        'atelier-cave-dark', 'atelier-sulphurpool-dark', 'gml', 'nord', 'tomorrow-night-blue',
        'atelier-cave-light', 'atelier-sulphurpool-light', 'googlecode', 'obsidian', 'tomorrow-night-bright',
        'atelier-dune-dark', 'atom-one-dark', 'grayscale', 'ocean', 'tomorrow-night',
        'atelier-dune-light', 'atom-one-dark-reasonable', 'gruvbox-dark', 'paraiso-dark', 'tomorrow-night-eighties',
        'atelier-estuary-dark', 'atom-one-light', 'gruvbox-light', 'paraiso-light', 'vs2015',
        'atelier-estuary-light', 'brown-paper', 'hopscotch', 'pojoaque', 'vs',
        'atelier-forest-dark', 'codepen-embed', 'hybrid', 'purebasic', 'xcode',
        'atelier-forest-light', 'color-brewer', 'idea', 'qtcreator_dark', 'xt256',
        'atelier-heath-dark', 'darcula', 'ir-black', 'qtcreator_light', 'zenburn',
        'atelier-heath-light', 'dark', 'isbl-editor-dark', 'railscasts'
    );

    $themes = &$themes9131;
    if(! in_array($theme, $themes)) { $theme = 'default'; }

    // Only one theme per page, to be effective theme needs to be set
    // on all directive calls, theme specific css changes needs to be done
    // in script calling this adapter. See test/Test.Precode.php sample.
    # NOTE: set the same value in wiki text
    #  eg. ```python showlines=1 theme=github

/////////////////////////////

    global $HTMLHeaderFmt, $HTMLFooterFmt, $HTMLStylesFmt;

    $HTMLHeaderFmt['HighlightJS'] =  <<<EOF

<link rel='stylesheet' type='text/css' href='$HighlightJSPath/styles/$theme.css' />

EOF;
    $themecss =  <<<EOF
<style type='text/css'><!--
  pre.$theme code { background: none !important; }
  /* change as per theme, look at themes background color */
  pre.$theme { background: #F0F0F0 !important; }
  pre .layer1 { padding: 0.5em; }
--></style>
EOF;

    $_D = &$HTMLHeaderFmt['HighlightJSTheme'.$theme];
    if(isset($_D)) { $themecss = $_D; unset($_D); }
    // enable/disable for defaults
    $HTMLHeaderFmt['HighlightJSTheme'.$theme] = $themecss;

    $HTMLFooterFmt['HighlightJS'] =  "\n".<<<EOF
<script type='text/javascript' src='$HighlightJSPath/highlight.pack.js'></script>
<script type="text/javascript">
/*<![CDATA[*/
hljs.tabReplace = '    ';
//hljs.initHighlightingOnLoad();
hljs.initHighlighting();
/*]]>*/
</script>
EOF;


}

function PreCode2($pagename, $text, $args) {

    $PreCode = _PreCode($pagename, $text, $args);
    extract($PreCode, EXTR_OVERWRITE);

    static $highlights = array();
    include('adapter.base.php');

    $theme = $args['theme'];
    LoadHighlightJS($lang, $theme);

    $_id = " id='$id'"; $_idc = " id='$idc'";
    $_c = ($args['classreset'] !== '') ? $args['classreset'].$args['_c'] : '';
    $_c1 = ' class="'.$args['theme'].$showlines.' hs '.$args['classreset'].'"';
    $_c2 = ' class="'.$lang.' '.$_c.'"';
    return Keep('<pre'.$_id.$_c1.'><code'.$_idc.$_c2.'>'.$text.'</code></pre>');

}

