<?php if (!defined('PmWiki')) exit();

function LoadSyntaxlove($lang='', $theme='default') {

/////// ADJUST VALUES ///////

    $Array_Syntaxlove = array(
        "Bash"   => "1", "CSharp" => "0", "Css"     => "1", "Delphi" => "0",
        "Groovy" => "0", "Java"   => "0", "JScript" => "1", "Perl"   => "0",
        "Php"    => "1", "Plain"  => "1", "Python" => "1",  "Ruby"   => "0",
        "Scala"  => "0", "Sql"    => "1", "Vb"     => "0",  "Xml"    => "1"
    );

    $themes = array(
        'default' => 'Default', 'eclipse' => 'Eclipse', 'fadetogrey' => 'FadeToGrey',
        'midnight' => 'Midnight', 'django' => 'Django', 'emacs' => 'Emacs',
        'mdultra' => 'MDUltra', 'rdark' => 'RDark'
    );

    // only one theme per page at first directive
    $syntax_style = "shThemeDefault.css"; // eg. shThemeEmacs.css
    $theme = strtolower($theme);
    if(array_key_exists($theme, $themes)) { $syntax_style = 'shTheme'.$themes["$theme"].'.css'; }

/////////////////////////////

    global $HTMLHeaderFmt, $HTMLFooterFmt, $HTMLStylesFmt;

/*
 * Download and install Syntaxlove
 * http://www.pmwiki.org/wiki/Cookbook/Syntaxlove
 */
include_once('cookbook/syntaxlove.php');

    $HTMLFooterFmt['SyntaxHActivate'] = "\n".<<<EOF
<script type="text/javascript">
/*<![CDATA[*/
     //SyntaxHighlighter.defaults['gutter'] = true;
     SyntaxHighlighter.config.tagName = "code";
/*]]>*/
</script>
EOF;

}

function PreCode2($pagename, $text, $args) {

    global $Array_Syntaxlove;

    $PreCode = _PreCode($pagename, $text, $args);
    extract($PreCode, EXTR_OVERWRITE);

    static $highlights = array(); $delay = 300;
    include('adapter.base.php');

    $langs =  array(
        'bash', 'css', 'jscript', 'php', 'plain',
        'python', 'sql', 'xml', 'html'
    );
    if($lang) trim($lang);
    if(! in_array($lang, $langs)) { $lang = 'plain'; }

    LoadSyntaxlove($lang, $args['theme']);

    $brush = syntaxlove_options($lang.' '. $str_args);

    $_id = " id='$id'"; $_idc = " id='$idc'";
    $_c = ($args['classreset'] !== '') ? $args['classreset'].$args['_c'] : '';
    $_c1 = ' class="'.$args['theme'].$showlines.' hs '.$args['classreset'].'"';
    $_c2 = ' class="'.$brush.' '.$_c.'"';
    return Keep('<pre'.$_id.$_c1.'><code'.$_idc.$_c2.'>'.$text.'</code></pre>');

}

